#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "GaussianTransform.h"

void main(int argc, char *argv[])
{
	char c;
	GaussianTransform *g=new GaussianTransform();

/*	if (!g->readData("gData.txt"))
	{
		printf("Read error");
		// hold for user input (input not used)
		scanf("%c",&c);
		exit(-1);
	}
*/

	g->generateData(0,65536,65536,0,2,0,65536,65536,0);

	g->startTimer();
	// run direct calculation of gausian transform
	g->slow_gt();
	g->stopTimer();
	// print out results
	printf("Gaussian Transform computed directly:\n");
	g->printTime();
//	g->output_results();
	// hold for user input (input not used)
//	scanf("%c",&c);
	
	g->startTimer();
	// run direct evalution using fourier series
	g->trunc_gt(10);
	g->stopTimer();
	// print out results
	printf("Gaussian Transform computed directly, but truncated:\n");
	g->printTime();
//	g->output_results();
	// hold for user input (input not used)
//	scanf("%c",&c);

	g->startTimer();
	// run direct evalution using fourier series
	g->appr_gt(20);
	g->stopTimer();
	// print out results
	printf("Gaussian Transform computed directly, using Fourier Series approximation:\n");
	g->printTime();
//	g->output_results();
	// hold for user input (input not used)
//	scanf("%c",&c);

	g->startTimer();
	// run direct evalution using fourier series
	g->fast_gt(20);
	g->stopTimer();
	// print out results
	printf("Gaussian Transform computed using fast method and Fourier Series approximation:\n");
	g->printTime();
//	g->output_results();
	// hold for user input (input not used)
	scanf("%c",&c);

	delete g;
}

